Dim fso, filename, wshShell, objShell
Set fso = CreateObject("Scripting.FileSystemObject")
Set wshShell = CreateObject("WScript.Shell")

parameters = ""
copyParameters = ""
p_source = ""
p_destination = ""
p_copyA = ""
p_copyD = ""
p_copyT = ""
p_copyS = ""
p_copyO = ""
p_copyU = ""
p_dcopy = ""
p_mir = ""
p_backup = ""
p_restartable = ""
p_retry = ""
p_wait = ""
p_excludejunction = ""
p_log = ""
p_sub = ""
p_custom = ""
p_excludeolder = ""
ExcludeFolderString = ""
ExcludeFileString = ""
profile_name=""
logfile = ""

currentdate = CStr(Year(Date))
If Month(Date) < 10 Then
	currentdate = currentdate + "0" + CStr(Month(Date))
Else
	currentdate = currentdate + CStr(Month(Date))
End If
If Day(Date) < 10 Then
	currentdate = currentdate + "0" + CStr(Day(Date))
Else
	currentdate = currentdate + CStr(Day(Date))
End If


Set objArgs = WScript.Arguments
If WScript.Arguments.Count < 1 Then
	WScript.Echo "Invalid Syntax"
	WScript.Echo "Usage: ARGUI-CLI.vbs <profile file>"
	WScript.Echo
Else
	loadfile(objArgs(0))
	run
End If



Sub loadFile(filename)
	If filename = "" Then
		SetDefault
		Exit Sub
	End If
	If fso.FileExists(filename) = False Then
		Msgbox "File " + filename + " does not exists"
		SetDefault
		Exit Sub
	End If
	Dim file
	Set file = fso.OpenTextFile(filename, 1, True, -1) 'read as unicode
	
	Do Until file.AtEndOfStream
		text=file.readLine
		
		If InStr(text,"Source=") > 0 Then
			p_source = Right(text,Len(text)-(Len("Source=")))
		End If
		If InStr(text,"Destination=") > 0 Then
			p_destination = Right(text,Len(text)-(Len("Destination=")))
		End If
		If InStr(text,"Custom=") > 0 Then
			p_custom = Right(text,Len(text)-(Len("Custom=")))
		End If
		
		Dim item
		If InStr(text,"ExcludeFolder=") > 0 Then
			folders = Split(Right(text,Len(text)-(Len("ExcludeFolder="))), "/")
			For Each itemx in folders
				ExcludeFolderString = ExcludeFolderString + Chr(34) + itemx + Chr(34) + " "
			Next
			RTrim(ExcludeFolderString)
		End If
		If InStr(text,"ExcludeFile=") > 0 Then
			files = Split(Right(text,Len(text)-(Len("ExcludeFile="))), "/")
			For Each itemx in files
				ExcludeFileString = ExcludeFileString + Chr(34) + itemx + Chr(34) + " "
			Next
			RTrim(ExcludeFileString)
		End If
		If InStr(Text,"CopyParameterD=True") > 0 Then
			p_copyD = "D"
		End If
		If InStr(Text,"CopyParameterA=True") > 0 Then
			p_copyA = "A"
		End If
		If InStr(Text,"CopyParameterT=True") > 0 Then
			p_copyT = "T"
		End If
		If InStr(Text,"CopyParameterS=True") > 0 Then
			p_copyS = "S"
		End If
		If InStr(Text,"CopyParameterO=True") > 0 Then
			p_copyO = "O"
		End If
		If InStr(Text,"CopyParameterU=True") > 0 Then
			p_copyU = "U"
		End If
		
		copyParameters = p_copyD+p_copyA+p_copyT+p_copyS+p_copyO+p_copyU
		
		If InStr(Text,"CopyDirectoryTimestampsTrue") > 0 Then
			p_dcopy = "/DCOPY:T"
		End If
		If InStr(Text,"SubDirectory=True") > 0 Then
			p_sub = "/E"
		End If
		If InStr(Text,"Mirror=True") > 0 Then
			p_mir = "/PURGE"
		End If
		If InStr(Text,"ExcludeJunction=True") > 0 Then
			p_excludejunction = "/XJ"
		End If
		If InStr(Text,"Restartable=True") > 0 Then
			p_restartable = "/Z"
		End If
		If InStr(Text,"Backup=True") > 0 Then
			p_backup = "/B"
		End If
		If InStr(text,"Retry=") > 0 Then
			p_retry = "/R:" + Right(text,Len(text)-(Len("Retry=")))
		End If
		If InStr(text,"Wait=") > 0 Then
			p_wait = "/W:" + Right(text,Len(text)-(Len("Wait=")))
		End If
		If InStr(Text,"ExcludeJunction=True") > 0 Then
			p_excludeolder = "/XO"
		End If		
	Loop
	
	file.Close
	If p_custom = "" Then
		parameters = p_sub + " " +p_dcopy + " " + p_excludejunction + " " + p_restartable + " " + p_backup + " " + p_wait + " " + p_retry + " " + p_mir + " " + p_excludeolder
		If copyParameters <> "" Then
			parameters = parameters + " /COPY:"+copyParameters
		End If
		parameters = Trim(parameters)
		parameters = parameters + " /NP /TEE"
	Else
		parameters = p_custom
	End If
	
	profile_name = fso.getBaseName(filename)
	logfile = Chr(34) + profile_name + "_" + currentdate + ".txt" + Chr(34)
End Sub



Sub Run
	'Check for root folder
	If Right(p_source,1) <> "\" Then
		p_source = Chr(34) + p_source + Chr(34)
		WScript.Echo "$RECYCLE.BIN, System Volume Information folder and pagefile.sys file will be automatically excluded"
		ExcludeFolderString = ExcludeFolderString + " $RECYCLE.BIN " + Chr(34) + "System Volume Information" + Chr(34)
		ExcludeFileString = ExcludeFileString + " pagefile.sys"
	Else
		WScript.Echo "$RECYCLE.BIN, System Volume Information folder and pagefile.sys file will be automatically excluded"
		ExcludeFolderString = ExcludeFolderString + " $RECYCLE.BIN " + Chr(34) + "System Volume Information" + Chr(34)
		ExcludeFileString = ExcludeFileString + " pagefile.sys"
	End If
	
	If Right(p_destination,1) <> "\" Then
		p_destination = Chr(34) + p_destination+ Chr(34)
	End If

	execution = "robocopy " + p_source + " " + p_destination + " /XD " + ExcludeFolderString + " /XF " + ExcludeFileString + " " + parameters + " /LOG+:" + logfile
	
	WScript.Echo "ARGUI - Command Line Interface"
	WScript.Echo
	WScript.Echo "The following command will execute:"
	WScript.Echo execution
	WScript.Echo 
	wshShell.Run(execution)
End Sub



